 ;*****************************************************
 ;***    **************************
 ; AutoCAD 2000, 2004, 2005
 ;  :   2004 .
 ;      ""
 ; E-mail  psw@asc.inep.net
;******************************************************************
(defun C:PSW (/	A1 A200	A2000 AMAX AR ED EN H II L1
	      LABEL N N1 N2 NAME OB S1 SS T00 T1 V2 V3
	     )
    (setvar "CMDECHO" 0)
    (setvar "HPBOUND" 1)
    (setq SS NIL)

    (setq SS (ssadd))
    (setq LABEL (entlast))

    (setq T1 (getpoint "\n  : "))
    (setq T00 T1)
    (setq S1 (ssadd))
    (setq L1 (entlast))

    (command "_-boundary" T1 "")
    (while
	(setq LABEL (entnext LABEL))
	   (setq SS (ssadd LABEL SS))
    )
    ;******************************************************************
    (setq A200 NIL)
    (setq II 0)
    (if	(/= SS NIL)
	(progn
	    (setq N (sslength SS))
	    (repeat N
		(setq EN (ssname SS II))
		(setq ED (entget EN))
		(setq V2 (assoc -1 ED))
		(setq V3 (cdr (assoc 0 ED)))
		(if (= V3 "LWPOLYLINE")
		    (progn
			(command "_region" EN "")
			(setq EN (entlast))
			(setq NAME (vlax-ename->vla-object EN))
			(setq AR (vlax-get-property NAME 'AREA))
			(setq A200 (cons (list EN AR) A200))
		    )
		)
		(setq II (+ II 1))
	    )
	)
    )
 ;*****************************************************
    (setq A2000	(vl-sort A200
			 (function
			     (lambda (E1 E2)
				 (> (cadr E1)
				    (cadr E2)
				 )
			     )
			 )
		)
    )
 ;*****************************************************
    (setq II 1)
    (setq N1 (car (nth 0 A2000)))
    (setq A1 (cadr (nth 0 A2000)))
    (setq N (- (length A2000) 1))
    (repeat N
	(setq N2 (car (nth II A2000)))
	(command "_subtract" N1 "" N2 "")
	(setq II (+ 1 II))
	(setq N1 (entlast))
    )
 ;*****************************************************
    (setq EN (entlast))
    (setq NAME (vlax-ename->vla-object EN))
    (setq AMAX (vlax-get-property NAME 'AREA))
    (entdel EN)
 ;*****************************************************
    (command "_-bhatch" "_p" "Solid" "_a" "_S" "_o" "" T00 "")
    (setq OB (entlast))
    (prompt "\nPress any key ... ")
    (setq H (grread))
    (entdel ob)
    (while
	(setq L1 (entnext L1))
	   (setq S1 (ssadd L1 S1))
    )
    (command "_ERASE" S1 "")
 ;*****************************************************    
    (prompt "\n*****************************************************************\n")
 ;(setq AMAX (/ AMAX 1000.0 1000.0))
    (prompt (strcat " = " (rtos AMAX 2 8) " 2.           "))
    (prompt (strcat " = " (rtos (/ AMAX 1000000.0) 2 2) " 2."))
    (setvar "FILEDIA" 1)
    (princ)
) ;defun
